



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>XAF应用开发教程(三)业务对象模型之引用类型与关联关系</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">XAF应用开发教程(三)业务对象模型之引用类型与关联关系</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-29 16:16:47 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>本节介绍信息系统开发中最常见的问题，引用关系，一对多关系，多对多关系。</p>
<p>以客户信息为例，客户通常需要客户分类，如VIP客户，普通客户，潜在客户。当然，我们可以定义枚举类型进行定义出这个类型，并在客户类上面定义对应的属性。</p>
<p>但枚举类型增加值需要修改程序，而客户分类很可能是会增加或是修改的，此时，我们就需要用到了引用类型。引用类型对应到数据库上，也就是外键关系。</p>
<p>既然是需要可以维护的客户分类，那么我们应该建立一张表出来，在XPO中就要新建出一个业务类，代码如下：</p>
<div>
<pre class="prettyprint linenums">    [DefaultClassOptions]<br />　　[XafDefaultProperty("名称")]<br />
    public class 客户分类 : BaseObject<br />
    {<br />
        public 客户分类(Session s):base(s)<br />
        {

        }

        private string _名称;<br />
        public string 名称<br />
        {<br />
            get { return _名称; }<br />
            set { SetPropertyValue("名称", ref _名称, value); }<br />
        }<br />
    }</pre>
</div>
<p>代码相当的简单，只有一个属性。运行系统后，客户分类已经出现在菜单中，接下来，要在客户中填加客户分类属性。</p>
<div>
<pre class="prettyprint linenums">        private 客户分类 _客户分类;<br />
        public 客户分类 客户分类<br />
        {<br />
            get { return _客户分类; }<br />
            set { SetPropertyValue("客户分类", ref _客户分类, value); }<br />
        }</pre>
</div>
<p>接下来按下F5运行系统，看看效果。</p>
<p>从导航栏点击客户，再次点击新建，可以看到如下效果的编辑器。你的运行效果中没有VIP和普通用户这两个值吗？</p>
<p>对的，可以直接点击图中所示的倒数第二个按钮，可以新建出可选项。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222143234499-1614143521.png" /></p>
<p>回过头来看一下我们新使用的属性：</p>
<div>
<pre class="prettyprint linenums">[DefaultClassOptions]<br />
    <strong>[XafDefaultProperty(</strong><strong>"名称")]<br />
    </strong>public class 客户分类 : BaseObject<br />
    { .....<br />
    }</pre>
</div>
<p>可以看到客户分类上面使用了新的Attribute,XafDefaultPropertyAttribute,它的功能是：当类实例被显示时，使用哪个属性做为显示值，如果去掉这句话效果如下：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222143758702-129803963.png" /></p>
<p>可以看出来，显示的是类的全名（一串GUID），这个GUID就是主键字段的值。后面如果看到这种情况，你应该知道需要设置XafDefaultProperty就好了。</p>
<p>引用型字段使用的是搜索编辑器，当数据条数大于25时，将会自动的显示为弹出搜索窗口。我们可以手工向客户分类表中新建超过25条记录。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222144355577-1138700464.png" /></p>
<p>可以看到，这时的图标变成了望远镜，点击后，弹出窗口：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222144617890-590310098.png" /></p>
<p>在弹出窗口中，按下搜索按钮，就显示出了所有记录。当然还有很多可以控制的选项，但本节主要介绍引用型关系的使用，所以不做深入讨论，后面会详细介绍。</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222144923499-992182355.png" /></p>
<p>再来看看数据库中表的变化，客户分类字段已经建立出来，并且是外键。这种建立外键的机制对数据完整性有很好的约束。当然也是可以不建立出外键的。</p>
<p>下面再来看看一对多关系的建立方法，有这样的需求：一个客户有多个联系人，一个联系人只属于一个客户。</p>
<p>我们先新建一个联系人类型：</p>
<div>
<pre class="prettyprint linenums">    [XafDefaultProperty("名称")]<br />
    public class 联系人 : BaseObject<br />
    {<br />
        public 联系人(Session s):base(s)<br />
        {

        }

        private string _名称;<br />
        public string 名称<br />
        {<br />
            get { return _名称; }<br />
            set { SetPropertyValue("名称", ref _名称, value); }<br />
        }

        private 客户 _客户;<br />
        [Association]<br />
        public 客户 客户<br />
        {<br />
            get { return _客户; }<br />
            set { SetPropertyValue("客户", ref _客户, value); }<br />
        }

    }</pre>
</div>
<p>同时，在客户类中填加一个集合属性：</p>
<div>
<pre class="prettyprint linenums">public class 客户.......<br />
{<br />
 .............<br />
        [Association]<br />
        public XPCollection&lt;联系人&gt; 联系人<br />
        {<br />
            get { return GetCollection&lt;联系人&gt;("联系人"); }<br />
        }<br />
..............<br />
}</pre>
</div>
<p>这里可以看到，在客户类中 联系人属性是 xpcollection&lt;联系人&gt; ，而在联系人类中，有客户属性，它们都用了[Association]进行了标记。</p>
<p>是的，这个标记就是用来建立关联关系的。F5运行一下看看效果吧！</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222150402359-984003694.png" /></p>
<p>在客户列表中，点击新建，可以看到下方多了一个联系人列表，是的，这里可以存储多个联系人信息了。在联系人列表上，可以点击&ldquo;New"按钮进行填加数据了。</p>
<p>下面再来看看多对多关系的建立，在实现项目开发中，有这样一种情形，公司为了销售业务，通常会有业务大区的概念，一个客户可能存在于两个业务大区中，如</p>
<p>公司销售在上海市普陀区，嘉定区均有营业网点，客户在嘉定区居住，但离普陀区很近，可能去普陀区销费，那么我们可以建立大区类、和客户类是多对多的关联关系：</p>
<div>
<pre class="prettyprint linenums"><strong>    [NavigationItem("基础数据"</strong><strong>)]</strong><br />
    [XafDefaultProperty("名称")]<br />
    public class 销售大区 : BaseObject<br />
    {<br />
        public 销售大区(Session s ):base(s)<br />
        {

        }

        private string _名称;<br />
        public string 名称<br />
        {<br />
            get { return _名称; }<br />
            set { SetPropertyValue("名称", ref _名称, value); }<br />
        }

        [Association]<br />
        public XPCollection&lt;客户&gt; 客户<br />
        {<br />
            get { return GetCollection&lt;客户&gt;("客户"); }<br />
        }<br />
    }</pre>
</div>
<p>上面的代码就新建出了销售大区类型，可以看到新建的类型上我使用了</p>
<pre class="prettyprint linenums"><strong>[NavigationItem("基础数据"</strong><strong>)]这样一个Attribute,它的功能是在导航菜单中，建一个导航分组，并把销售大区这个业务对象的列表显示在里面。<br /></strong></pre>
<div>
<pre class="prettyprint linenums">public class 客户.....<br />
{<br />
..................<br />
       [Association]<br />
        public XPCollection&lt;销售大区&gt; 所属大区<br />
        {<br />
            get { return GetCollection&lt;销售大区&gt;("所属大区"); }<br />
        }<br />
...................<br />
}</pre>
</div>
<p>在客户类中增加一个所属大区属性，如上所示，这样一个对多对关系就建立完成了。可以看出，和一对多其实是一样的，只是两个类中都用xpcollection&lt;T&gt;这个泛型类即可。</p>
<p>还是F5看下效果吧：</p>
<p><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222152341921-852749443.png" /></p>
<pre class="prettyprint linenums"><strong>可以看到，销售大区被放到了基础数据下面点击后，出现了销售大区的列表，这时，还没有数据。<br /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222152525781-1757778736.png" /><br />在销售大区上点击新建，可以看到客户列表出现在销售大区的详细界面中了。这里点击Link按钮，可以选择大区所拥有的客户。<br />同样的，来看客户信息：<br /><img referrerpolicy="no-referrer"src="https://images2015.cnblogs.com/blog/669762/201512/669762-20151222153740577-884281871.png" /><br />这时，所属大区被放到了第二个Tab页面中，XAF会判断有几个子级列表类型的集合，而建立出Tab.<br />如果你一直和我一样，一直使用中文编码，点开所属大区会是空白的，这是Dev的BUG,将会在15.2.5版本中修复，临时的解决方法是这样的：<br />解决方案-&gt;XCRMDemo.Web-&gt;WebApplication.cs，右键，查看代码，来到构造函数中，加入如下语句：<br /></strong></pre>
<div>
<pre class="prettyprint linenums">   public XCRMDemoAspNetApplication() {<br />
            InitializeComponent();<br />
            DelayedViewItemsInitialization = false;<br />
        }</pre>
</div>
<p>这句话的意思是Tab中的内容不是在点击时生成的，对性能上会有些影响，后面的版本中BUG修复了就没有问题了。</p>
<p>这个BUG的原因是因为浏览器中的cookieName使用了中文编码，而chrome,firefox，都不支持，在safari浏览器中没有这个问题。</p>
<p>浏览器我一直推荐使用chrome，速度快！</p>
<p>学习了上面的三节知识后，就可以构建多数的表结构了，怎么样快试试吧！</p>
<p><a href="http://www.cnblogs.com/%20http:/files.cnblogs.com/files/foreachlife/CRMDemo.7z" rel="external nofollow noreferrer">文章示例项目源码下载</a></p>
<pre class="prettyprint linenums"><a href="http://www.cnblogs.com/%20http:/files.cnblogs.com/files/foreachlife/CRMDemo.7z" rel="external nofollow noreferrer"><strong>QQ:4603528 QQ群：336090194</strong></a></pre>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/g8ewmzx8.html">asp&period;net中的ListBox控件添加双击事件</a>
		</li>
						<li><a href="https://www.batexi.com/a/495dzgvq.html">PLC M8000 M8001 M8002 M8003</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8o27ll9.html">【开源分享：入门到精通ASP&period;NET MVC&plus;EF6&plus;Bootstrap】从这里开始，一起搭框架（1）开篇介绍</a>
		</li>
						<li><a href="https://www.batexi.com/a/96odw3y9.html">UML图示</a>
		</li>
						<li><a href="https://www.batexi.com/a/90v5vdm8.html">java数组遍历&mdash;&mdash;iterator和for方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1z61e49.html">CocoaPods使用详细说明&lpar;转&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyezdx9.html">ESRI Shapefiles &lpar;SHP&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mvl738.html">VC6迁移到VS2008几个问题&mdash;&mdash;良好的代码，从我做起，从现在开始。</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge3pe48.html">WebService使用入门&lpar;包括发布服务，调用服务&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9ge4rkz8.html">使用django-compressor压缩静态文件</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnjggwj8.html">GUI（GroupLayout 分组布局）</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1x20mq.html">WEB 小案例 -- 网上书城（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8oj03jpq.html">javascript属性访问表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/8me51j0q.html">&lbrack;翻译&rsqb; EF Core in Action 关于这本书</a>
		</li>
						<li><a href="https://www.batexi.com/a/9rge4zd8.html">Centos7 防火墙 firewalld 实用操作</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7ox54g8.html">Java并发编程阅读笔记-同步容器、工具类整理</a>
		</li>
						<li><a href="https://www.batexi.com/a/9r51zneq.html">关于使用jmeter函数助手生成随机数的使用方法</a>
		</li>
						<li><a href="https://www.batexi.com/a/960km1n9.html">redis工具类 ----RedisPoolUtil</a>
		</li>
						<li><a href="https://www.batexi.com/a/qnvpdr28.html">Ubuntu 14&period;10 下SSH配置</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pwlopz8.html">python补充3</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/q7mxjmkq.html">MAVEN修改localRepository不起作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/9gm1x7z9.html">OC基础数据类型-NSData</a>
			</li>
						<li><a href="https://www.batexi.com/a/96ojgz49.html">Jquery知识</a>
			</li>
						<li><a href="https://www.batexi.com/a/96oj2249.html">YTU 3008&colon; 链串的基本运算</a>
			</li>
						<li><a href="https://www.batexi.com/a/8oknrvx9.html">2015-09-17 001 存储过程数据操作类 H&lowbar;data&lowbar;Helper</a>
			</li>
						<li><a href="https://www.batexi.com/a/8z1gzl19.html">JS实现base64编码与解码</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1mxo38.html">CentOS安装solr 4&period;10&period;3</a>
			</li>
						<li><a href="https://www.batexi.com/a/qn1mx338.html">JavaScript的构造器与对象（二）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qvv5ldjq.html">WPFの布局中Panel的选用</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde022v9.html">JS脚本语言里的循环</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
